#include "PPlayerObject.h"
#include "PEnemyObject.h"
#include "PTireSparkObject.h"
#include "PPodObject.h"
#include "PExitObject.h"
#include "PBossObject.h"
#include "PBossBulletObject.h"
#include "PBossBomberObject.h"
#include "PBossLaserObject.h"
#include "PBossTurrentObject.h"
 
PBaseObject::PBaseObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) {
	
	this->x = x;
	this->y = y;
        this->type = type;
	this->radius = radius;
	this->droptype = droptype;
	this->goingRight = goingRight;
        this->offset = offset;
	this->levelSystem = levelSys;
	currentAnimation = 0;
	dead = 0;
	
}

PBaseObject* PBaseObject::CreateObject(RTTI_OBJECTTYPE ot, short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) {

	switch (ot) {
			
		case RTTI_Player:
			return dynamic_cast<PBaseObject*>(new PPlayerObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_Enemy:
			return dynamic_cast<PBaseObject*>(new PEnemyObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_TireSpark:
			return dynamic_cast<PBaseObject*>(new PTireSparkObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_Pod:
			return dynamic_cast<PBaseObject*>(new PPodObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_Exit:
			return dynamic_cast<PBaseObject*>(new PExitObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_Boss:
			return dynamic_cast<PBaseObject*>(new PBossObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_BossBullet:
			return dynamic_cast<PBaseObject*>(new PBossBulletObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_BossBomber:
			return dynamic_cast<PBaseObject*>(new PBossBomberObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_BossLaser:
			return dynamic_cast<PBaseObject*>(new PBossLaserObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		case RTTI_BossTurrent:
			return dynamic_cast<PBaseObject*>(new PBossTurrentObject(x, y, type, radius, droptype, goingRight, offset, levelSys));
			break;
		default:
			return NULL;
			break;
	}
	
	return NULL;
}
