#include "PBossBomberObject.h"
#include "MainWidget.h"

PBossBomberObject::PBossBomberObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset,levelSys) {
	
	onGround = false;
	bstablizer.start();
}

PBossBomberObject::~PBossBomberObject() {
 	
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossBomberObject::render(ZSurface &backBuffer) {
	
	ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->bossBomber->image(getCurrentAnimation()));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossBomberObject::processAI() {

	   
	applyGravity();
					
	if (getCurrentAnimation() > 0)  //animate
		setCurrentAnimation(0);
	else
		setCurrentAnimation(1);
	
	if (bstablizer.elapsed() > 3000) {
		levelSystem->getMainWindow()->playSound(SOUND_Bomb);
		setCurrentAnimation(2);
		setDead(1);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PBossBomberObject::processDeadAI() {
	
	return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossBomberObject::getWidth() {
	return levelSystem->bossBomber->image(0)->width();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossBomberObject::getHeight() {
	
	return levelSystem->bossBomber->image(0)->height();
	
}

void PBossBomberObject::applyGravity() {

	if (onGround || dead == 1) 
		return;
	
	BYTE gravity = 10;
	BYTE secgrav = 10;
	
	
	short y = getY() + getHeight() + gravity;
	short x = getX() + (getWidth() >> 1); 
	
	if (y < 0)
		y *= -1;
	if (x < 0)
		x *= -1;                  
	
	short n = x / 30;                    //y position of tile jack is in after moving with graviy
	short m = y / 30;                    //x position of tile jack is in after moving with graviy
	
	if (m > 7) {
	
		
		setY(getY() + gravity);
		onGround = true;
		return;
		
	}
	
	if (m < 0) {
		setY(getY() + gravity);
	        return;
	}
	
	if (levelSystem->levelSet[m][n] != -1) {  //we collided - check finer
		
	
	        if (levelSystem->collisionSet[levelSystem->levelSet[m][n]][(y % 30)][(x % 30)] == 1) {  //we collided in the fine check... can't fall gravity number
			
		        bool falling = true;
		        while (falling) {
			     
			     gravity = secgrav;                       //move out last gravity into stored position
			     secgrav = gravity >> 1;                  //take half of that gravity and store it in our working variable
			     
			     y -= secgrav;
			     m = y / 30;        //recalculate our formula from earlier
			     
			     if (levelSystem->levelSet[m][n] == -1) {
				     return;
			     }
			     
			     if (levelSystem->collisionSet[levelSystem->levelSet[m][n]][(y % 30)][(x % 30)] == 1)  {  //we collided again..go smaller
				if (secgrav <= 1) {
					onGround = true;
					return;
				}
			     } else {
				//we are good to go here
				setY(getY() + secgrav);
				onGround = false;
				falling = false;
			     }
			}
		
		
	        } else {//we are good to go
			setY(getY() + gravity);
			onGround = false;
	                return;
		}
		
	} else {// else hey keep falling
		setY(getY() + gravity);
		onGround =false;
	        return;
	}
	
}



