///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Project: Jack the Uni-Psychle
//
// Author: Tim Newell
//
// License: GPL see LICENSE in main directory or /usr/share/JUP/ if you used the installer
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef PBOSSBOMBEROBJECT_H
#define PBOSSBOMBEROBJECT_H
#include "PBaseObject.h"
 
class PBossBomberObject : public PBaseObject {
	
public:

	PBossBomberObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys);
	//abstract deconstructor
	virtual ~PBossBomberObject();
	
	//abstract functions
	virtual RTTI_OBJECTTYPE getType() { return RTTI_BossBomber; }
	virtual void render(ZSurface &backBuffer);
	virtual void processAI();
	virtual bool processDeadAI();
	virtual UBYTE getWidth();
	virtual UBYTE getHeight();
	
	void applyGravity();
	
protected:
    	bool onGround;
	QTime bstablizer;
    
private:



};



#endif

