#include "PBossBulletObject.h"

PBossBulletObject::PBossBulletObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset,levelSys) {
	
	
}

PBossBulletObject::~PBossBulletObject() {
	
	 
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossBulletObject::render(ZSurface &backBuffer) {
	
	ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->getBossBullet()->image(getCurrentAnimation()));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossBulletObject::processAI() {

	if (getSubType() == 0) {   //tank bullets - horizontal
		
		if (getGoingRight() == false) {
			setX(getX() - 20);   //move
			if ((getX() + getWidth()) < 0) {
				setDead(1);
			}
		} else {
			setX(getX() + 20);   //move
			if (getX() > 240) {
				setDead(1);
			}
		}
	} else if (getSubType() == 1) {   //diagonal
	
		if (getGoingRight() == false) {
			setX(getX() - 20);   //move
			if ((getX() + getWidth()) < 0) {
				setDead(1);
			}
		} else {
			setX(getX() + 20);   //move
			if (getX() > 240) {
				setDead(1);
			}
		}
		
		setY(getY() + 20);
		if (getY() > 240)
			setDead(1);
	
	} else if (getSubType() == 2) {   //vertical
	
		setY(getY() + 20);
		if (getY() > 240)
			setDead(1);
	}

	if (getCurrentAnimation() > 0)  //animate
		setCurrentAnimation(0);
	else
		setCurrentAnimation(1);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PBossBulletObject::processDeadAI() {
	
	if ((getX() + getWidth()) < 0 || getX() > 240 || (getY() + getHeight()) < 0 || getY() > 240) {
		return false;
	}
	
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossBulletObject::getWidth() {
	return levelSystem->getBossBullet()->image(0)->width();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossBulletObject::getHeight() {
	
	if (levelSystem->getCurrentLevel() == 4) 
		return levelSystem->getBossBullet()->image(0)->height() + 10;
	else
		return levelSystem->getBossBullet()->image(0)->height();
	
}
