#include "PBossLaserObject.h"

PBossLaserObject::PBossLaserObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset,levelSys) {
	
	
}

PBossLaserObject::~PBossLaserObject() {
	
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossLaserObject::render(ZSurface &backBuffer) {
	
	ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->getBossLaser()->image(getCurrentAnimation()));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossLaserObject::processAI() {

	if (getSubType() == 0) {   //tank bullets
		
		if (getGoingRight() == false) {
			setX(getX() - 20);   //move
			if ((getX() + getWidth()) < 0) {
				setDead(1);
			}
		} else {
			setX(getX() + 20);   //move
			if (getX() > 240) {
				setDead(1);
			}
		}
			
		
		setCurrentAnimation(0);
					
	} else if (getSubType() == 1) {
		
		if (getGoingRight() == false) {
			setX(getX() - 20);   //move
			if ((getX() + getWidth()) < 0) {
				setDead(1);
			}
			setCurrentAnimation(1);
		} else {
			setX(getX() + 20);   //move
			if (getX() > 240) {
				setDead(1);
			}
			setCurrentAnimation(2);
		}
		
		setY(getY() - 20);
		if ((getY() + getHeight()) < 0) {
			setDead(1);
		}

		
	} else if (getSubType() == 2) {
		
		if (getGoingRight() == false) {
			setX(getX() - 20);   //move
			if ((getX() + getWidth()) < 0) {
				setDead(1);
			}
			setCurrentAnimation(2);
		} else {
			setX(getX() + 20);   //move
			if (getX() > 240) {
				setDead(1);
			}
			setCurrentAnimation(1);
		}
		
		setY(getY() + 20);
		if ((getY()) > 240) {
			setDead(1);
		}
		
	} else if (getSubType() == 3) {   //left down
		
		setY(getY() + 20);   //move
		if (getY() > 240) {
			setDead(1);
		}
		
		setX(getX() - 20);   //move
		if ((getX() + getWidth()) < 0) {
			setDead(1);
		}
		
		setCurrentAnimation(2);
	 	
	} else if (getSubType() == 4) {   //down
		
		setY(getY() + 20);   //move
		if (getY() > 240) {
			setDead(1);
		}
		
		setCurrentAnimation(3);
		
	} else if (getSubType() == 5) {   //right down
	
		setY(getY() + 20);   //move
		if (getY() > 240) {
			setDead(1);
		}
		
		setX(getX() + 20);   //move
		if (getX() > 240) {
			setDead(1);
		}
		
		setCurrentAnimation(1);
	
	}
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PBossLaserObject::processDeadAI() {
	
	if ((getX() + getWidth()) < 0 || getX() > 240 || (getY() + getHeight()) < 0 || getY() > 240) {
		return false;
	}
	
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossLaserObject::getWidth() {
	return levelSystem->getBossLaser()->image(getCurrentAnimation())->width();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossLaserObject::getHeight() {
	
	return levelSystem->getBossLaser()->image(getCurrentAnimation())->height();
	
}
