#include "PBossObject.h"
#include "PPlayerObject.h"
#include "MainWidget.h"
#include <stdio.h>

PBossObject::PBossObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset,levelSys) {
	
	bstablizer.start();
	tstablizer.start();
	hitpoints = 3;
	fired = false;
	stage = 0;
	bombsDropped = 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossObject::render(ZSurface &backBuffer) {
	
	if (getDropType() != 1 && getDropType() != 2 && getDropType() != 5 && getDropType() != 6) 
		ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->getBossImages(getSubType())->image(getCurrentAnimation()));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossObject::processAI() {
	
	//Animate
	if (getSubType() == 0) {
		
		if (getGoingRight() == false) {
			if (getCurrentAnimation() > 0) {
				setCurrentAnimation(0);
			} else {
				setCurrentAnimation(1);
			}
		} else {
			
			if (getCurrentAnimation() < 4 || getCurrentAnimation() > 4) {
				setCurrentAnimation(4);
			} else {
				setCurrentAnimation(5);
			}
			
		}
	//////////////////////////////////////////////////////////////////////////////
	} 
	
				
	//Move////////////////////////////////////////////////////////////////////////////////////////////
	if (getSubType() == 0) {
		
		//check to see if we fire
		if (fired == 1) {
			if (getGoingRight() == false)
				setCurrentAnimation(3);
			else
				setCurrentAnimation(7);
			fired = 0;
		}
		
		if (bstablizer.elapsed() > 3000) {
			//spawn the bullet
			if ((levelSystem->getPlayer()->getX() + (levelSystem->getPlayer()->getWidth() >> 1)) > ((getX() + (getWidth())))) {
				setGoingRight(true);
			} else
				setGoingRight(false);
				
				
			if (getGoingRight() == false) {
				setCurrentAnimation(2);
				levelSystem->getMainWindow()->playSound(SOUND_Bomb);
				levelSystem->AddObjectToSet(1, RTTI_BossBullet, getX()-2, getY()+25, 0, 0, 0, false, 0);
			} else {
				setCurrentAnimation(6);
				levelSystem->getMainWindow()->playSound(SOUND_Bomb);
				levelSystem->AddObjectToSet(1, RTTI_BossBullet, getX()+getWidth()+2, getY()+25, 0, 0, 0, true, 0);
			}
			fired = 1;
			bstablizer.restart();
		}
		
		if (tstablizer.elapsed() > 2000) {
			if (getGoingRight() == false) {
				setX(getX() - 10);
			
				if (getX() <= 0) {
					setGoingRight(true);
				}
		
		
			} else {
				
				setX(getX() + 10);
			
				if ((getX()+getWidth()) >= 240) {
					setGoingRight(false);
				}
			
			}
		}
	
	//////////////////////////////////////////////////////////////////////////////
	} 
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PBossObject::processDeadAI() {
	
	if (getSubType() == 0) {
		if (getDropType() == 0)
			levelSystem->getMainWindow()->playSound(SOUND_Attack);
		setDropType(getDropType() + 1);
		if (getDropType() >= 8) {
			setDropType(0);
			setDead(0);
			decHitPoints();

			if (getHitPoints() == 0) {
				//spawn the exit sign
				levelSystem->AddObjectToSet(1, RTTI_Exit, 165, 165, 0, 100, 0, true, 0);
				return false;
			}
		}
	
	//////////////////////////////////////////////////////////////////////////////
	} 
	
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossObject::getWidth() {
	
	return levelSystem->getBossImages(getSubType())->image(0)->width();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossObject::getHeight() {
	
	return levelSystem->getBossImages(getSubType())->image(0)->height();
}


