///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Project: Jack the Uni-Psychle
//
// Author: Tim Newell
//
// License: GPL see LICENSE in main directory or /usr/share/JUP/ if you used the installer
// 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef PBOSSOBJECT_H
#define PBOSSOBJECT_H
#include "PBaseObject.h"

class PBossObject : public PBaseObject {
	
public:

	PBossObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys);
	//abstract deconstructor
	virtual ~PBossObject(){}
	
	//abstract functions
	virtual RTTI_OBJECTTYPE getType() { return RTTI_Boss; }
	virtual void render(ZSurface &backBuffer);
	virtual void processAI();
	virtual bool processDeadAI();
	virtual UBYTE getWidth();
	virtual UBYTE getHeight();
	
	BYTE getHitPoints() { return hitpoints; }
        void setHitPoints(BYTE hp) { hitpoints = hp; }
        void decHitPoints() { hitpoints--; }
	
protected:
    
    
private:
	BYTE fired;
	BYTE hitpoints;
	QTime bstablizer;
	QTime tstablizer;
	BYTE stage;
	BYTE bombsDropped;

};



#endif

