#include "PBossTurrentObject.h"

PBossTurrentObject::PBossTurrentObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset,levelSys) {
	
	tstablizer.start();
	hitpoints = 3;
} 

PBossTurrentObject::~PBossTurrentObject() {
	
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossTurrentObject::render(ZSurface &backBuffer) {
	
	if (getDropType() != 1 && getDropType() != 2)
		ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->getBossTurrent()->image(getCurrentAnimation()));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PBossTurrentObject::processAI() {

	if ((levelSystem->getPlayer()->getX() + (levelSystem->getPlayer()->getWidth() >> 1)) > levelSystem->toLocalX((getX() + getWidth()))) {  //fire to the right
		setCurrentAnimation(4);
		//fireing
		if (tstablizer.elapsed() > 3000) {
			setCurrentAnimation(5);
			levelSystem->AddObjectToSet(1, RTTI_BossBullet, getX()+30, getY()+32, 1, 0, 0, true, 0);
			tstablizer.restart();
		}
	} else if ((levelSystem->getPlayer()->getX() + (levelSystem->getPlayer()->getWidth() >> 1)) < levelSystem->toLocalX(getX())) {  //fire to the left
		setCurrentAnimation(2);
		//fireing
		if (tstablizer.elapsed() > 3000) {
			setCurrentAnimation(3);
			levelSystem->AddObjectToSet(1, RTTI_BossBullet, getX()-17, getY()+32, 1, 0, 0, false, 0);
			tstablizer.restart();
		}
	} else {  //fire straight down
		setCurrentAnimation(0);
		//fireing
		if (tstablizer.elapsed() > 3000) {
			setCurrentAnimation(1);
			levelSystem->AddObjectToSet(1, RTTI_BossBullet, getX() + (getWidth() >> 1) - 11, getY()+getHeight(), 2, 0, 0, true, 0);
			tstablizer.restart();
		}
	}
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PBossTurrentObject::processDeadAI() {
	
	setDropType(getDropType() + 1);
		
	if (getDropType() >= 4) {

		setDropType(0);
		setDead(0);
		decHitPoints();

		if (getHitPoints() == 0) {
			levelSystem->decTurrents();
			return false;
		}
				
	}
			
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossTurrentObject::getWidth() {
	return levelSystem->getBossTurrent()->image(0)->width();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PBossTurrentObject::getHeight() {
	
	return levelSystem->getBossTurrent()->image(0)->height();
	
}
