#include "PEnemyObject.h"

PEnemyObject::PEnemyObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset,levelSys) {
	
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PEnemyObject::render(ZSurface &backBuffer) {
	 
	ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->enemyImages[getSubType()]->image(getCurrentAnimation()));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PEnemyObject::processAI() {
	
	if (getSubType() <= 5) {                  //walking enemy
		
		//Animate
		if (getSubType() == 0 || getSubType() == 1) {
			if (!getGoingRight()) {
				if (getCurrentAnimation() >= 2) {
					setCurrentAnimation(0);
				} else {
					incCurrentAnimation();
				}
			
			} else {
		
				if (getCurrentAnimation() >= 5 || getCurrentAnimation() <= 2) {
					setCurrentAnimation(3);
				} else {
					incCurrentAnimation();
				}	
			}
		} else if (getSubType() == 2 || getSubType() == 3 || getSubType() == 4 || getSubType() == 5) {
		
			if (!getGoingRight()) {
				if (getCurrentAnimation() >= 1) {
					setCurrentAnimation(0);
				} else {
					incCurrentAnimation();
				}
			} else {
		
		
				if (getCurrentAnimation() >= 3 || getCurrentAnimation() <= 1) {
					setCurrentAnimation(2);
				} else {
					incCurrentAnimation();
				}
			}
		}
	
		
		//Move
		if (levelSystem->getCurrentLevel() == 34) {
			if (getY() != (225-getHeight())) {
				setY(getY() + 30);
				if (getY() > (225-getHeight()))
					setY((225-getHeight()));
			}
			if (getY() == (225-getHeight())) {
				if (getGoingRight() == true) {
					setX(getX() + 5);
					if ((getX() + getWidth()) > 720) {
						setX(getX() - 5);
						setGoingRight(false);
					}
				} else {
					setX(getX() - 5);
					if ((getX()) < 0) {
						setX(getX() + 5);
						setGoingRight(true);
					}
				}
			}
		} else {
			if (getOffset() >= 0) {   //going right
				if (getGoingRight() == true) {
					if (getOffset() < getRadius()) {
						setOffset(getOffset() + 5);
						if (getOffset() > getRadius()) 
							setX(getX() + 5 - (getOffset() - getRadius()));
						else
							setX(getX() + 5);
					} else {
						setGoingRight(false);
					}
				} else {
					if (getOffset() > -2) {
						setOffset(getOffset() - 5);
						setX(getX() - 5);
					}
				}
		
			}  else {  //going left
				if (getGoingRight() == false) {
					if (getOffset() > (getRadius() * -1)) {
						setOffset(getOffset() - 5);
						if ((getOffset() * -1) > getRadius()) 
							setX(getX() - 5 - ((getOffset() * -1) - getRadius()));
						else
							setX(getX() - 5);
					} else {
						setGoingRight(true);
					}
				} else {
					if (getOffset() < 1) {
						setOffset(getOffset() + 5);
						setX(getX() + 5);
					}
				}
			}
		}
		
	} else {                                  //jumping enemy
				
		BYTE jumpspeed = 10;
		if (getGoingRight() == true) {
			if ((getOffset() + jumpspeed) >= getRadius()) {
				setGoingRight(false);
				jumpspeed -= (getOffset() + jumpspeed) - getRadius();
				if (jumpspeed < 0)
					jumpspeed = 0;
				setOffset(getRadius());
			}

			setY(getY() - jumpspeed);
			setOffset(getOffset() + jumpspeed);

		} else {
			if ((getOffset() - jumpspeed) <= 0) {
				setGoingRight(true);
				jumpspeed += (getOffset() - jumpspeed);
				if (jumpspeed < 0)
					jumpspeed = 0;
				setOffset(0);
			}


			setY(getY() + jumpspeed);
			setOffset(getOffset() - jumpspeed);
		}



		if (getCurrentAnimation() == 0) {
			setCurrentAnimation(1);
		} else {
		        setCurrentAnimation(0);
		}

	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PEnemyObject::processDeadAI() {

	if (levelSystem->getPlayer()->getGoingRight()) {
		setX(getX() + 3);
		setY(getY() + 30);
	} else {
		setX(getX() - 3);
		setY(getY() + 30);
	}
	
	if (getY() > 280) {
		return false;   ///this enemy needs deleting
	}
	
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PEnemyObject::getWidth() {

	return levelSystem->enemyImages[getSubType()]->image(0)->width();
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PEnemyObject::getHeight() {
	
	return levelSystem->enemyImages[getSubType()]->image(0)->height();
	
}
