#include "PPlayerObject.h"
#include "MainWidget.h"

PPlayerObject::PPlayerObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset, levelSys) {
	
	centered = true;
        jump = false;
        push = false;
        onGround = false;
        jumpeddistance = 0;
        lives = 3;
	numTires = 0;
	strcpy(deadText,"");
	dstablizer.start();

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::render(ZSurface &backBuffer) {
	
	//Now draw the player on top
	ZSurface::bitBlitAlpha(&backBuffer,getX(), getY(), levelSystem->playerImages->image(getCurrentAnimation()));
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::processAI() {

	checkEnemyCollision();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PPlayerObject::processDeadAI() {
	
	if (getGoingRight() == true) {
		if (dstablizer.elapsed() > 75) {
			if (getCurrentAnimation() < 12 || getCurrentAnimation() >= 14)
				setCurrentAnimation(12);
			else
				incCurrentAnimation();
			dstablizer.restart();
		}
	
		setX(getX() - 5);
		if (getDropType() > -60) {
			setY(getY() - 5);
			setDropType(getDropType() - 5);
		}
		if (getDropType() <= -60) {
			setY(getY() + 10);
		}
	} else {
		if (dstablizer.elapsed() > 75) {
			if (getCurrentAnimation() < 15 || getCurrentAnimation() >= 17)
				setCurrentAnimation(15);
			else
				incCurrentAnimation();
			dstablizer.restart();
		}
	
		setX(getX() + 5);
		if (getDropType() > -60) {
			setY(getY() - 5);
			setDropType(getDropType() - 5);
		}
		if (getDropType() <= -60) {
			setY(getY() + 10);
		}
		
	}
	return true;
}
 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::checkEnemyCollision() {
	
	//2 pt check for dying
	short x = getX() + 6;
	short y = getY() + (getHeight() >> 1) + 5;
	//short y2 = getY() + (getHeight() >> 1) - 10;
	short x2 = x + getWidth() - 6;
	//reuse first y
	
	for (short i = 0; i < levelSystem->objectCount; i++) {      //loop through the different objects
		if (levelSystem->objectSet[i] != NULL) {
			if (levelSystem->objectSet[i]->getX() >= (levelSystem->CurrentX-120) && levelSystem->objectSet[i]->getX() <= (levelSystem->CurrentX+360)) {
					
				//Kill enemy if collide
				if (((x >= levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) && 
				    x <= levelSystem->toLocalX(levelSystem->objectSet[i]->getX() + levelSystem->objectSet[i]->getWidth())) ||
				    (x2 >= levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) &&
				           x2 <= levelSystem->toLocalX(levelSystem->objectSet[i]->getX() + levelSystem->objectSet[i]->getWidth()))) &&
				    (y >= levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) && 
				    y <= levelSystem->toLocalY(levelSystem->objectSet[i]->getY() + levelSystem->objectSet[i]->getHeight())) /*||
				    (y2 >= levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) && 
				    y2 <= levelSystem->toLocalY(levelSystem->objectSet[i]->getY() + levelSystem->objectSet[i]->getHeight()))*/) {
				
						if (levelSystem->objectSet[i]->getType() == RTTI_Enemy) {          //enemies
							
							if (levelSystem->objectSet[i]->getDead() == 0) {
								if (getDead() == 0) 
									died();
								return;
							}
						
						} else  if (levelSystem->objectSet[i]->getType() == RTTI_TireSpark) {
							if (levelSystem->objectSet[i]->getSubType() == 0) {
								levelSystem->getMainWindow()->playSound(SOUND_Wheel);
								if (levelSystem->getDubs())
									numTires += 20;
								else
									numTires++;
								if (numTires >= 100) {
									levelSystem->getMainWindow()->playSound(SOUND_ExtraLife);
									lives++;
									numTires = numTires - 100;
								}
								delete levelSystem->objectSet[i];
								levelSystem->objectSet[i] = NULL;
								return;
							
							} else {
								levelSystem->getMainWindow()->playSound(SOUND_ExtraLife);
								lives++;
								delete levelSystem->objectSet[i];
								levelSystem->objectSet[i] = NULL;
								return;
								
							}
							
						} else  if (levelSystem->objectSet[i]->getType() == RTTI_Boss) {
							if (levelSystem->objectSet[i]->getDead() == 0) {
								 
								if (getDead() == 0) 
									died();
								return;
								
							}
						
						} else if (levelSystem->objectSet[i]->getType() == RTTI_BossBullet) {
							if (getDead() == 0) 
								died();
							return;
						} else if (levelSystem->objectSet[i]->getType() == RTTI_BossLaser) {
							if (getDead() == 0) 
								died();
							return;	
						} else if (levelSystem->objectSet[i]->getType() == RTTI_BossBomber) {
							levelSystem->getMainWindow()->playSound(SOUND_Bomb);
							levelSystem->objectSet[i]->setCurrentAnimation(2);
							levelSystem->objectSet[i]->setDead(1);
							if (getDead() == 0) 
								died();
							return;
						} 
						
				} 
				
				if (levelSystem->objectSet[i]->getType() == RTTI_Exit) {
				
				
					if (((x >= levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) && 
					      x <= levelSystem->toLocalX(levelSystem->objectSet[i]->getX() + levelSystem->objectSet[i]->getWidth())) ||
					      (x2 >= levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) &&
					      x2 <= levelSystem->toLocalX(levelSystem->objectSet[i]->getX() + levelSystem->objectSet[i]->getWidth()))) &&
					      y >= levelSystem->toLocalY(levelSystem->objectSet[i]->getY() - levelSystem->objectSet[i]->getRadius()) && 
					      y <= levelSystem->toLocalY(levelSystem->objectSet[i]->getY() + levelSystem->objectSet[i]->getHeight() + levelSystem->objectSet[i]->getRadius())) {
					    
							levelSystem->levelFinished = true;
							return;
					}
				}
			}
		}
	}
	
	
	
	
	if (!onGround) {   //check kill point for enemies 0-5
		
		short x = getX() + (getWidth() >> 1) - 9;
		short x2 = x + 18;
		short y = getY() + getHeight() - 3;
		
		for (short i = 0; i < levelSystem->objectCount; i++) {      //loop through the different objects
			if (levelSystem->objectSet[i] != NULL) {
				if (levelSystem->objectSet[i]->getX() >= (levelSystem->CurrentX-120) && levelSystem->objectSet[i]->getX() <= (levelSystem->CurrentX+360)) {
					
					//Kill enemy if collide
					if (((x >= levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) &&
					    x <= levelSystem->toLocalX(levelSystem->objectSet[i]->getX() + levelSystem->objectSet[i]->getWidth())) ||
					    (x2 >= levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) &&
					    x2 <= levelSystem->toLocalX(levelSystem->objectSet[i]->getX() + levelSystem->objectSet[i]->getWidth()))) &&
					    y >= levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) && 
					    y <= levelSystem->toLocalY(levelSystem->objectSet[i]->getY() + levelSystem->objectSet[i]->getHeight())) {
						    if (levelSystem->objectSet[i]->getType() == RTTI_Enemy) {          //enemies
							    if (levelSystem->objectSet[i]->getDead() == 0) {		
								    if (levelSystem->objectSet[i]->getSubType() <= 5) {  
										
										levelSystem->getMainWindow()->playSound(SOUND_Attack);
										levelSystem->objectSet[i]->setDead(1);
										if (levelSystem->objectSet[i]->getDropType() != 0) {
											levelSystem->DropObjects(levelSystem->objectSet[i]);
										}
										//make player jump
										jumpeddistance = 0;
										onGround = true;
										jump = true;
										return;
									
								    } else {                                          //jumping enemy
				
										if (getDead() == 0)
											died();
										return;
								    }
				
							    }
						    } else if (levelSystem->objectSet[i]->getType() == RTTI_Boss) {  
							    if (levelSystem->objectSet[i]->getDead() == 0) {
								    if (levelSystem->objectSet[i]->getSubType() == 0 || levelSystem->objectSet[i]->getSubType() == 1 ||
								        levelSystem->objectSet[i]->getSubType() == 3) {
									    	
										levelSystem->getMainWindow()->playSound(SOUND_Attack);
										levelSystem->objectSet[i]->setDead(1);
										//make player jump
										jumpeddistance = 0;
										onGround = true;
										jump = true;
										return;
								    }
							    }
						}
			
					}
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::animate(BYTE x) {
	
	if (getGoingRight()) {
		
		if (x > 0) {
			
		     if ((getCurrentAnimation() == 0 || getCurrentAnimation() == 4) && getCurrentAnimation() != 8 && getCurrentAnimation() != 9) {
			     setCurrentAnimation(8);
		     } else if (getCurrentAnimation() == 8) {
			     setCurrentAnimation(9);
		     } else if (getCurrentAnimation() >= 3) {
			     setCurrentAnimation(1);
		     } else {
			     incCurrentAnimation();
		     }
		} else {
			
		     if (levelSystem->getMainWindow()->slide == true) {
			     setCurrentAnimation(0);
			     return;
		     }
			
		     if (getCurrentAnimation() != 0 && getCurrentAnimation() != 8 && getCurrentAnimation() != 9) {
			     setCurrentAnimation(9);
		     } else if (getCurrentAnimation() == 9) {
			     setCurrentAnimation(8);
		     } else if (getCurrentAnimation() == 8 || getCurrentAnimation() == 0) {
			     setCurrentAnimation(0);
		     }
		}
		
		
	} else {
		
		if (x < 0) {
			
			if ((getCurrentAnimation() == 0 || getCurrentAnimation() == 4) && getCurrentAnimation() != 10 && getCurrentAnimation() != 11) {
			     setCurrentAnimation(10);
		     } else if (getCurrentAnimation() == 10) {
			     setCurrentAnimation(11);
		     } else if (getCurrentAnimation() >= 7 || getCurrentAnimation() <= 3) {
			     setCurrentAnimation(5);
		     } else {
			     incCurrentAnimation();
		     }
		} else {
			
		     if (levelSystem->getMainWindow()->slide == true) {
			     setCurrentAnimation(4);
			     return;
		     }
		     
		     if (getCurrentAnimation() != 4 && getCurrentAnimation() != 10 && getCurrentAnimation() != 11) {
			     setCurrentAnimation(11);
		     } else if (getCurrentAnimation() == 11) {
			     setCurrentAnimation(10);
		     } else if (getCurrentAnimation() == 10 || getCurrentAnimation() == 4) {
			     setCurrentAnimation(4);
		     }
		}
	}
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::applyGravity(bool gravadjust, bool chkenemy) {

	if (dead == 1)
		return;
		
	if (chkenemy)
		checkEnemyCollision();
		
	if (!jump && jumpeddistance == 0 && onGround) {
		return;
	}
     	
	
	BYTE gravity = 5;
	BYTE secgrav = 5;
	
	
	//jumping stuff///////////////////////////////////////////////////////////////////////////////////////////////
	if (jump) {
	 
	 	if (jumpeddistance > 75) {  //is ?? for PC is 75 for Zaurus
	           gravity = secgrav = -2;
		   jumpeddistance += 2;
		} else if (jumpeddistance > 50 && jumpeddistance <= 65) {  //is ?? to ?? for PC is 50 to 65 for Zaurus
		   gravity = secgrav = -4;
		   jumpeddistance += 4;
                } else if (jumpeddistance <= 50) {  //is ?? for PC is 50 for Zaurus
		      gravity = secgrav = -5;
		      jumpeddistance += 5;
                } else if (jumpeddistance > 65 && jumpeddistance <= 70) {  //is ?? to ?? for PC is 65 to 70 for Zaurus
		   gravity = secgrav = -5;
		   jumpeddistance += 5;
	        } else if (jumpeddistance > 70 && jumpeddistance <= 75) {  //is ?? to ?? for PC is 70 to 75 for Zaurus
		   gravity = secgrav = -3;
		   jumpeddistance += 3;
		}
		
	} else if (!jump && jumpeddistance > 0 && gravadjust == false) {
	    
	      if (jumpeddistance > 75) {  //is ?? for PC is 75 for Zaurus
	           gravity = secgrav = 2;
		   jumpeddistance -= 2;
	      } else if (jumpeddistance > 50 && jumpeddistance <= 65) {  //is ?? to ?? for PC is 50 to 65 for Zaurus
		   gravity = secgrav = 4;
		   jumpeddistance -= 4;
	      } else if (jumpeddistance <= 50) {  //is ?? for PC is 50 for Zaurus
		      gravity = secgrav = 5;
		      jumpeddistance -= 5;
              } else if (jumpeddistance > 65 && jumpeddistance <= 70) {  //is ?? to ?? for PC is 65 to 70 for Zaurus
		   gravity = secgrav = 5;
		   jumpeddistance -= 5;
	      } else if (jumpeddistance > 70 && jumpeddistance <= 75) {  //is ?? to ?? for PC is 70 to 75 for Zaurus
		   gravity = secgrav = 3;
		   jumpeddistance -= 3;
	      }
		
	}
	//jumping stuff end //////////////////////////////////////////////////////////////////////////////////////////
	
	//short y = getY() + getHeight() - 40 + gravity;
	//short x = levelSystem->CurrentX + (centered?120:(120+(((getOffset() > 0)?(getOffset()+(getWidth() >> 1)):(getOffset()-(getWidth() >> 1))))));
	short y = getY() + getHeight() - 40 + gravity - 3;
	short x = levelSystem->CurrentX + (centered?(111):(111 +(((getOffset() > 0)?(getOffset()+(getWidth() >> 1)):(getOffset()-(getWidth() >> 1))))));
	short x2 = levelSystem->CurrentX + (centered?(129):(129 +(((getOffset() > 0)?(getOffset()+(getWidth() >> 1)):(getOffset()-(getWidth() >> 1))))));
	
	//if (y < 0)
	//	y *= -1;
//	if (x < 0)
//		x *= -1;
//	if (x2 < 0)
//		x2 *= -1;
		
	short n = x / 30;                    //y position of tile jack is in after moving with graviy
	short m = y / 30;                    //x position of tile jack is in after moving with graviy
	short p = x2 / 30;
	
	if (m == 0) {
		if (y < 0)
			y *= -1;
	}
	
	
	if (jump) {
		setY(getY() + gravity);
		onGround =false;
	        return;
	}
	
	if (m > 7) {
	
		setY(getY() + gravity);
		onGround =false;
		died();
		setY(getY() + 180);
		return;
		
	}
	
	if (m <= 0) {
		setY(getY() + gravity);
		onGround =false;
	        return;
	}
	
	if (levelSystem->levelSet[m][n] != -1) {  //we collided - check finer
		
	
	        if (levelSystem->collisionSet[levelSystem->levelSet[m][n]][(y % 30)][(x % 30)] == 1) {  //we collided in the fine check... can't fall gravity number
			
		        bool falling = true;
		        while (falling) {
			     
			     gravity = secgrav;                       //move out last gravity into stored position
			     secgrav = gravity >> 1;                  //take half of that gravity and store it in our working variable
			     
			     y -= secgrav;
			     m = y / 30;        //recalculate our formula from earlier
			
			     
			     if (levelSystem->levelSet[m][n] == -1) {
				    return;
			     }
			     
			     if (levelSystem->collisionSet[levelSystem->levelSet[m][n]][(y % 30)][(x % 30)] == 1)  {  //we collided again..go smaller
				if (secgrav <= 1) {
					onGround = true;
					return;
				}
			     } else {
						     
				     //we are good to go here
				     setY(getY() + secgrav);
				     onGround = false;
				     falling = false;
				   
				     
			     }
			}
		
		
	        } else if (levelSystem->levelSet[m][p] != -1 && levelSystem->collisionSet[levelSystem->levelSet[m][p]][(y % 30)][(x2 % 30)] == 1) {  //we collided in the fine check... can't fall gravity number
			
			bool falling = true;
		        while (falling) {
			     
			     gravity = secgrav;                       //move out last gravity into stored position
			     secgrav = gravity >> 1;                  //take half of that gravity and store it in our working variable
			     
			     y -= secgrav;
			     m = y / 30;        //recalculate our formula from earlier
			
			     
			     if (levelSystem->levelSet[m][p] == -1) {
				    return;
			     }
			     
			     if (levelSystem->collisionSet[levelSystem->levelSet[m][p]][(y % 30)][(x2 % 30)] == 1)  {  //we collided again..go smaller
				if (secgrav <= 1) {
					onGround = true;
					return;
				}
			     } else {
						     
				     //we are good to go here
				     setY(getY() + secgrav);
				     onGround = false;
				     falling = false;
				   
				     
			     }
			}
			
			
			
		} else {
			setY(getY() + gravity);
			onGround = false;
	                return;
		}
		
	} else if (levelSystem->levelSet[m][p] != -1) {
		
		if (levelSystem->collisionSet[levelSystem->levelSet[m][p]][(y % 30)][(x2 % 30)] == 1) {  //we collided in the fine check... can't fall gravity number
		
			bool falling = true;
		        while (falling) {
			     
			     gravity = secgrav;                       //move out last gravity into stored position
			     secgrav = gravity >> 1;                  //take half of that gravity and store it in our working variable
			     
			     y -= secgrav;
			     m = y / 30;        //recalculate our formula from earlier
			
			     
			     if (levelSystem->levelSet[m][p] == -1) {
				    return;
			     }
			     
			     if (levelSystem->collisionSet[levelSystem->levelSet[m][p]][(y % 30)][(x2 % 30)] == 1)  {  //we collided again..go smaller
				if (secgrav <= 1) {
					onGround = true;
					return;
				}
			     } else {
						     
				     //we are good to go here
				     setY(getY() + secgrav);
				     onGround = false;
				     falling = false;
				   
				     
			     }
			}
		
		
	        } else {//we are good to go
			setY(getY() + gravity);
			onGround = false;
	                return;
		}
		
	} else {// else hey keep falling
		setY(getY() + gravity);
		onGround =false;
	        return;
	}
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PPlayerObject::checkWallCollision(BYTE move) {
	
	BYTE cmove = 1;
	BYTE secmove = 1;
	bool checking = true;
	
	if (move == 0 && jump == false)
		return true;
	
	while (checking) {
		
		short x;
		short y;
		
		//if (jump) {
		//	x = levelSystem->CurrentX + (centered?120:(120 + (((getOffset() > 0)?(getOffset()+(getWidth() >> 1)):(getOffset()-(getWidth() >> 1)))))) + secmove;  
		//	y = (getY()-40);
	//	} else {
			x = levelSystem->CurrentX + (centered?120:(120 + (((getOffset() > 0)?(getOffset()+(getWidth() >> 1)):(getOffset()-(getWidth() >> 1)))))) + ((move < 0)?((-1 * (getWidth() >> 1)) - secmove):((getWidth() >> 1) + secmove)); 
			y = (getY()-40) + (getHeight() >> 1) - 20;
	//	}
		short n = x / 30;
		short m = y / 30;
		
		if (m > 7) {
		     return false;
	        }
		
		if (m <= 0) {
		     return false;	
		}
		
		if (n >= levelSystem->gMapWidth) {
		    return false;	
		}
		
		if (levelSystem->levelSet[m][n] != -1) {  //we collided - check finer
		
			if (levelSystem->collisionSet[levelSystem->levelSet[m][n]][(y % 30)][(x % 30)] == 1) {  //we collided in the fine check... can't move
			      checking = false;
			      if (jump) {
				      jump = false;
				      jumpeddistance = 0;
			      }
			      return true;
			}
		
		}
		
		
		if (secmove == 10) {
			checking = false;
			return false;
		}
			
		cmove = secmove;                       //move out last move into stored position
	        secmove = cmove << 1;                  //multiply that move and store it in our working variable
		
		if (secmove > 8)
			secmove = 10;
	}
	
	return false;
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::died() {
	levelSystem->getMainWindow()->playSound(SOUND_TimerOut);
	dead = 1;
	if (levelSystem->getInfLives() == false)
		lives--;
	if (lives == 0) {
	     strcpy(deadText,"Game Over");	
	} else {
	     strcpy(deadText,"You're Dead");	
	}
	setDropType(0);
	dstablizer.restart();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PPlayerObject::pushDetect() {
	
	//Check for enemy
	//Grab Player's Square.. then loop through checking the 4 squares in front of players
	short y = getY() + ((getHeight() >> 1) >> 1) - 40;
	short x = (centered?120:(120+(((getOffset() > 0)?(getOffset()+(getWidth() >> 1)):(getOffset()-(getWidth() >> 1))))));                   
	short n = x / 30;                    //x position of tile jack is in
	short m = y / 30;                    //y position of tile jack is in
	
	
	for (short i = 0; i < levelSystem->objectCount; i++) {      //loop through the different objects
		if (levelSystem->objectSet[i] != NULL) {
			
			if (levelSystem->getPsychicStorm() == true && levelSystem->objectSet[i]->getType() == RTTI_Enemy && levelSystem->objectSet[i]->getDead() == 0) {
				levelSystem->objectSet[i]->setDead(1);
				if (levelSystem->objectSet[i]->getDropType() != 0) {
					levelSystem->DropObjects(levelSystem->objectSet[i]);
				}
				
			}
			
			if (levelSystem->objectSet[i]->getX() >= (levelSystem->CurrentX-120) && levelSystem->objectSet[i]->getX() <= (levelSystem->CurrentX+360)) {
				if (levelSystem->objectSet[i]->getType() == RTTI_Enemy) {          //enemies
				    if (levelSystem->objectSet[i]->getDead() == 0) {
					if (levelSystem->objectSet[i]->getSubType() > 5) {                  //jumping enemy
						if ((levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) >= getX() - 150) && 
						    (levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) <= (getX() + getWidth() + 150))) {
							//we are in possible X range	
							short ey = levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) + (levelSystem->objectSet[i]->getHeight() >> 1) - 40;
							short ex = levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) + (levelSystem->objectSet[i]->getWidth() >> 1);                   
							short en = ex / 30;                    //x position of tile enemy is in
							short em = ey / 30;                    //y position of tile enemy is in
					        	
							if (em == m) {
						
								if (getGoingRight()) {
								
									if (n == en || (n+1) == en || (n+2) == en || (n+3) == en || (n+4) == en) {
								
								     		//kill enemy
										levelSystem->getMainWindow()->playSound(SOUND_Attack);
										levelSystem->objectSet[i]->setDead(1);
										if (levelSystem->objectSet[i]->getDropType() != 0) {
											levelSystem->DropObjects(levelSystem->objectSet[i]);
										}
										return;
								
									}
								} else {
								
									if (n == en || (n-1) == en || (n-2) == en || (n-3) == en || (n-4) == en) {
									
										//kill enemy
										levelSystem->getMainWindow()->playSound(SOUND_Attack);
										levelSystem->objectSet[i]->setDead(1);
										if (levelSystem->objectSet[i]->getDropType() != 0) {
											levelSystem->DropObjects(levelSystem->objectSet[i]);
										}
										return;
									
									}
								}
							
							}
						}
					
					}
				    }
			
				} else if (levelSystem->objectSet[i]->getType() == RTTI_Pod) {  //pod
				
				
					if ((levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) >= getX() - 150) &&
					    (levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) <= (getX() + getWidth() + 150))) {
							//we are in possible X range	
							short ey = levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) + (levelSystem->objectSet[i]->getHeight() >> 1) - 40;
							short ex = levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) + (levelSystem->objectSet[i]->getWidth() >> 1);                   
							short en = ex / 30;                    //x position of tile enemy is in
							short em = ey / 30;                    //y position of tile enemy is in
					        	
							if (em == m) {
						
								if (getGoingRight()) {
								
									if (n == en || (n+1) == en || (n+2) == en || (n+3) == en || (n+4) == en) {
								
										if (levelSystem->objectSet[i]->getCurrentAnimation() != 1) {
										
											if (levelSystem->objectSet[i]->getDropType() != 0) {
												levelSystem->getMainWindow()->playSound(SOUND_Pod);
												levelSystem->DropObjects(levelSystem->objectSet[i]);
											}
											levelSystem->objectSet[i]->setCurrentAnimation(1);
											levelSystem->objectSet[i]->setDropType(0);
											return;
										}
									}
								} else {
								
									if (n == en || (n-1) == en || (n-2) == en || (n-3) == en || (n-4) == en) {
										
										if (levelSystem->objectSet[i]->getCurrentAnimation() != 1) {
											if (levelSystem->objectSet[i]->getDropType() != 0) {
												levelSystem->DropObjects(levelSystem->objectSet[i]);
											}
											levelSystem->objectSet[i]->setCurrentAnimation(1);
											levelSystem->objectSet[i]->setDropType(0);
											return;
										}
									}
								}
							
							}
					}
				} else if (levelSystem->objectSet[i]->getType() == RTTI_Boss) {  
				
					if (levelSystem->objectSet[i]->getDead() == 0) {
						if (levelSystem->objectSet[i]->getSubType() == 2 || levelSystem->objectSet[i]->getSubType() == 4) {                 
							
							    //we are in possible X range	
							    short ey = levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) + (levelSystem->objectSet[i]->getHeight() >> 1) - 40;
							    short ex = levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) + (levelSystem->objectSet[i]->getWidth() >> 1);                   
							    if (levelSystem->objectSet[i]->getSubType() == 4)
								    y = y + ((levelSystem->objectSet[i]->getHeight() >> 1) >> 1);
							    
							    short en = ex / 30;                    //x position of tile enemy is in
							    short em = ey / 30;                    //y position of tile enemy is in
					        	    
							    if ((em == m) || ((em - 1) == m) || ((em + 1) == m)) {
						
									if (getGoingRight()) {
								
										if (n == en || (n+1) == en || (n+2) == en || (n+3) == en || (n+4) == en) {
								
								     			//damage boss
											levelSystem->objectSet[i]->setDead(1);
											return;
								
										}
									} else {
								
										if (n == en || (n-1) == en || (n-2) == en || (n-3) == en || (n-4) == en) {
									
											//damage boss
											levelSystem->objectSet[i]->setDead(1);
											return;
									
										}
									}
							    }
						        
					      }
				    }
				
				} else if (levelSystem->objectSet[i]->getType() == RTTI_BossTurrent) {
					if (levelSystem->objectSet[i]->getDead() == 0) {
						//we are in possible X range	
						short ey = levelSystem->toLocalY(levelSystem->objectSet[i]->getY()) + (levelSystem->objectSet[i]->getHeight() >> 1) - 40;
						short ex = levelSystem->toLocalX(levelSystem->objectSet[i]->getX()) + (levelSystem->objectSet[i]->getWidth() >> 1);                   
						short en = ex / 30;                    //x position of tile enemy is in
						short em = ey / 30;                    //y position of tile enemy is in
					        
						if ((em == m) || ((em - 1) == m)) {
						
							if (getGoingRight()) {
							
								if (n == en || (n+1) == en || (n+2) == en || (n+3) == en || (n+4) == en) {
							
									//damage turrent
									levelSystem->getMainWindow()->playSound(SOUND_Attack);
									levelSystem->objectSet[i]->setDead(1);
									return;
							
								}
							} else {
								
								if (n == en || (n-1) == en || (n-2) == en || (n-3) == en || (n-4) == en) {
									
									//damage turrent
									levelSystem->getMainWindow()->playSound(SOUND_Attack);
									levelSystem->objectSet[i]->setDead(1);
									return;
									
								}
							}
						}
						        
					      
					}
				
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PPlayerObject::getWidth() { 
	return levelSystem->playerImages->image(0)->width(); 
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PPlayerObject::getHeight() { 
	return levelSystem->playerImages->image(0)->height(); 
}

