///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Project: Jack the Uni-Psychle
//
// Author: Tim Newell
//
// License: GPL see LICENSE in main directory or /usr/share/JUP/ if you used the installer
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef PPLAYEROBJECT_H
#define PPLAYEROBJECT_H
#include "PBaseObject.h"

class PBaseObject;
class PLevelSystem;

class PPlayerObject : public PBaseObject {
	
public:

	PPlayerObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys);
	//abstract deconstructor
	virtual ~PPlayerObject(){}
	
	//abstract functions
	virtual RTTI_OBJECTTYPE getType() { return RTTI_Player; }
	virtual void render(ZSurface &backBuffer);
	virtual void processAI();
	virtual bool processDeadAI();
	virtual UBYTE getWidth();
	virtual UBYTE getHeight();
 	
	void checkEnemyCollision();
	void pushDetect();
	bool checkWallCollision(BYTE move);
	void applyGravity(bool gravadjust = false, bool chkenemy = true);
	void animate(BYTE x);
	void died();
	
	void setCentered(bool _centered) { centered = _centered; }
	bool getCentered() { return centered; }
	void setJump(bool _jump) { jump = _jump; }
	bool getJump() { return jump; }
	void setPush(bool _push) { push = _push; }
	bool getPush() { return push; }
	void setOnGround(bool _onGround) { onGround = _onGround; }
	bool getOnGround() { return onGround; }
	void setJumpedDistance(BYTE _dis) { jumpeddistance = _dis; }
	BYTE getJumpedDistance() { return jumpeddistance; }
	void setLives(BYTE _lives) { lives = _lives; }
	BYTE getLives() { return lives; }
	void setNumTires(BYTE _numTires) { numTires = _numTires; }
	BYTE getNumTires() { return numTires; }
	void setDeadText(const char* _text) { strcpy(deadText,_text); }
	char* getDeadText() { return deadText; }
	
protected:
    
    
private:
	
	bool centered;
        bool jump;
        bool push;
        bool onGround;
        BYTE jumpeddistance;
        BYTE lives;
	BYTE numTires;
	char deadText[20];
	QTime dstablizer;
	
	

};



#endif

