#include "PTireSparkObject.h"

PTireSparkObject::PTireSparkObject(short x, short y, BYTE type, UBYTE radius, BYTE droptype, bool goingRight, short offset, PLevelSystem* levelSys) 
		   : PBaseObject(x,y,type,radius,droptype,goingRight,offset, levelSys) {
	
 	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PTireSparkObject::render(ZSurface &backBuffer) {
	
	if (getSubType() == 0) 
		ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->tire->image(getCurrentAnimation()));
	else
		ZSurface::bitBlitAlpha(&backBuffer,levelSystem->toLocalX(getX()), levelSystem->toLocalY(getY()), levelSystem->spark->image(getCurrentAnimation()));
		
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void PTireSparkObject::processAI() {
	
	if (getSubType() == 0) {
	
		if (getCurrentAnimation() >= 3) {
			setCurrentAnimation(0);
		} else {
			incCurrentAnimation();
		}
	
	} else {
		//spark - 2 images
		if (getCurrentAnimation() == 0) 
			setCurrentAnimation(1);
		else
			setCurrentAnimation(0);
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool PTireSparkObject::processDeadAI() {
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PTireSparkObject::getWidth() {
	
	if (getSubType() == 0) {
		return levelSystem->tire->image(0)->width();
	} else {
		return levelSystem->spark->image(0)->width();
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
UBYTE PTireSparkObject::getHeight() {
	
	if (getSubType() == 0) {
		return levelSystem->tire->image(0)->height();
	} else {
		return levelSystem->spark->image(0)->height();
	}
}


