///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Project: Jack the Uni-Psychle
//
// Author: Tim Newell
//
// License: GPL see LICENSE in main directory or /usr/share/JUP/ if you used the installer
// 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef PZSURFACEARRAY_H
#define PZSURFACEARRAY_H
#include "CustomDefines.h"
//ZSurface includes
#include "../zsurface/ZSurface.h"
#include "../zsurface/ZFont.h"


//This class is a replacement for QCanvasPixmapArray for use with ZSurface

class PZSurfaceArray {

public:
	//Constructor//////////////////////////////////////////////////////////////////////////////
	PZSurfaceArray(const char *path1, const char *path2, BYTE number) {
		
		imageCount = number;
		
		imageArray = new ZSurface*[imageCount];   //allocate our array
		
		for (BYTE i = 0; i < imageCount; i++) {   //create ZSurfaces
			QString tmp(path1);
			
			if (i < 10)
				tmp = tmp + "000";
			else
				tmp = tmp + "00";
				
			imageArray[i] = new ZSurface(QPixmap(tmp + QString::number(i) + path2), true);
			
		}
	}
	
	//Deconstructor////////////////////////////////////////////////////////////////////////////
	~PZSurfaceArray() {
	
		for (BYTE i = 0; i < imageCount; i++) {   //create ZSurfaces
			delete imageArray[i];
			imageArray[i] = NULL;
		}
		
		delete[] imageArray;
		
	
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////
	ZSurface* image(BYTE number) {
		return imageArray[number];
	}

private:
	ZSurface **imageArray;
	BYTE imageCount;
};

#endif
